set helpMsg "Usage: POWplot ?-cmap code? ?fitsimage?
 code: 0 Chose the best colormap
       1 Force to install private pseudo colormap
       2 Force to use truecolor colormap (if don't have it will crash!) 
       3 Force to use screen default colormap"


set ppFitsDataType(8) 0
set ppFitsDataType(16) 1
set ppFitsDataType(32) 2
set ppFitsDataType(-32) 3
set ppFitsDataType(-64) 4

set instPos [lsearch $argv "-cmap"]
set colorCode 0

# if install colormap
if { $instPos != -1} {
    if { [catch {set colorCode [lindex $argv [expr $instPos+1]]}] == 1} {
	puts $helpMsg
	exit
    }
    if { ($colorCode != 0) && ($colorCode != 1) && ($colorCode != 2) \
	&& ($colorCode != 3) } {
	puts $helpMsg
	exit
    }	
    set argv [lreplace $argv $instPos $instPos]
    set argv [lreplace $argv $instPos $instPos]
    incr argc -2 
}

wm withdraw .
update idletask

global powWCS
global POW_LIBRARY
set POW_LIBRARY "$env(POW_LIBRARY)/.."
# auto_load 
load [glob $POW_LIBRARY/libfitstcl.s\[ol\]*]
load [glob $POW_LIBRARY/libpow.s\[ol\]*]

# try to avoid the flash. 
powSetupColormap .dummy 6 $colorCode
wm withdraw .dummy

powInit .dummy

set filename [lindex $argv 0]
regsub -all {[^a-zA-Z0-9]} $filename "_" gname


if {$argc == 1} {
    set filehandle [fits open $filename]
    set imghandle [$filehandle load image]
    set dims [$filehandle info imgdim]
    set n1 [lindex $dims 0]
    set n2 [lindex $dims 1]
    set data_type [lindex [lindex [$filehandle get keyword BITPIX] 0] 1]
    set data_type $ppFitsDataType($data_type)
    if { ([catch {$filehandle get keyword BZERO}] == 0) ||
         ([catch {$filehandle get keyword BSCALE}] == 0) } {
        set data_type 4
    }
    powCreateData ${gname}_data $imghandle $data_type [expr $n1 * $n2] 0
    powCreateImage ${gname}_img ${gname}_data \
	0 0 $n1 $n2 1 1 1 1 pixels pixels counts
    if { ! [catch  {$filehandle get imgwcs} wcsString] } {
	set powWCS(${gname}_img) $wcsString
    }
    powCreateGraph $gname NULL ${gname}_img \
	pixels pixels NULL NULL 300 300
}


bind .pow <<powExit>> {exit}

